/* FILE: myanisotropy.h            -*-Mode: c++-*-
 *
 * Simple uniaxial anisotropy, derived from Oxs_Energy class.
 */

#ifndef _MY_ANISOTROPY
#define _MY_ANISOTROPY

#include "nb.h"
#include "threevector.h"
#include "energy.h"
#include "key.h"
#include "simstate.h"
#include "mesh.h"
#include "meshvalue.h"
#include "scalarfield.h"
#include "vectorfield.h"

/* End includes */

class My_Anisotropy:public Oxs_Energy {
private:
  Oxs_OwnedPointer<Oxs_ScalarField> K1_init;
  Oxs_OwnedPointer<Oxs_ScalarField> K2_init;
  Oxs_OwnedPointer<Oxs_VectorField> axis_init;
  mutable OC_UINT4m mesh_id;
  mutable Oxs_MeshValue<OC_REAL8m> K1;
  mutable Oxs_MeshValue<OC_REAL8m> K2;
  mutable Oxs_MeshValue<ThreeVector> axis;

protected:
  virtual void GetEnergy(const Oxs_SimState& state,
			 Oxs_EnergyData& oed) const;

public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  My_Anisotropy(const char* name,  // Child instance id
                       Oxs_Director* newdtr, // App director
                       const char* argstr);  // MIF input block parameters

  virtual ~My_Anisotropy() {}
  virtual OC_BOOL Init();
};


#endif // _MY_ANISOTROPY
