/* FILE: simpleanisotropy.h            -*-Mode: c++-*-
 *
 * Simple uniaxial anisotropy, derived from Oxs_Energy class.
 */

#ifndef _OXS_SIMPLEANISOTROPY
#define _OXS_SIMPLEANISOTROPY

#include "nb.h"
#include "threevector.h"
#include "energy.h"
#include "key.h"
#include "simstate.h"
#include "mesh.h"
#include "meshvalue.h"
#include "scalarfield.h"
#include "vectorfield.h"

/* End includes */

class Oxs_SimpleAnisotropy:public Oxs_Energy {
private:
  Oxs_OwnedPointer<Oxs_ScalarField> K1_init;
  Oxs_OwnedPointer<Oxs_VectorField> axis_init;
  mutable OC_UINT4m mesh_id;
  mutable Oxs_MeshValue<OC_REAL8m> K1;
  mutable Oxs_MeshValue<ThreeVector> axis;

protected:
  virtual void GetEnergy(const Oxs_SimState& state,
			 Oxs_EnergyData& oed) const;

public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  Oxs_SimpleAnisotropy(const char* name,  // Child instance id
                       Oxs_Director* newdtr, // App director
                       const char* argstr);  // MIF input block parameters

  virtual ~Oxs_SimpleAnisotropy() {}
  virtual OC_BOOL Init();
};


#endif // _OXS_SIMPLEANISOTROPY
